/*
 * Copyright (c) 2002, 2005 Sendmail, Inc. and its suppliers.
 *	All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 *
 *	$Id: socket.h,v 1.8 2010/03/03 02:27:42 ca Exp $
 */

#ifndef SM_SOCKET_H
#define SM_SOCKET_H 1

#if HAVE_SYS_SOCKET_H
# include <sys/socket.h>
#endif

#include "sm/error.h"
#include "sm/sockcnf.h"

sm_ret_T sock_connect(sockspec_P _sock, uint _flags, int *_pfd);
sm_ret_T sock_listen(sockspec_P _sock, int _backlog, uint _flags, int *_pfd);
sm_ret_T socket_accept(int _listenfd, sm_sockaddr_P _addr, sockaddr_len_T *_addrlen, int *_pfd);

sm_ret_T parsesockstr(const char *_sockstr, sockspec_P _sockspec);

sm_ret_T sockspec2sock(sockspec_P _sockspec, sm_sockaddr_P _sm_sockaddr, sockaddr_len_T *_psock_size, uint _flags);

#define SS2S_FL_NONE	0x0000
#define SS2S_FL_RMUNIX	0x0001	/* remove unix socket */

#endif /* SM_SOCKET_H */
