#!/bin/sh
# $Id: t-msgmod-4.sh,v 1.2 2006/10/05 04:27:40 ca Exp $
# Copyright (c) 2005 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ----------------------------------------
# test message body modifications: replacing headers
# uses t-msgmod-0
# ----------------------------------------
#
test -s stop && exit 1
#

GREP=grep
ERR=false
ERRS=0
if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

TPRG=./t-msgmod-0
IN=msg-4.in
OK=msg-4.ok
OUT=msg-4.out

cat > ${IN} <<EOF
From: a
To: b
Subject: first subject line
	continued subject
 last subject line

body
.
EOF


# ----------------------------------------
# test: replace header
TEST=1
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false

cat > ${OK} <<EOF
From: New Sender <some@domain>
To: b
Subject: first subject line
	continued subject
 last subject line

body
.
EOF

for i in 1 2 3 4 5 6 7 8 9 10 16 32 128 256
do
  ${TPRG} -b ${i} -r '0=From: New Sender <some@domain>' < ${IN} > ${OUT}
  if diff ${OK} ${OUT}
  then
     :
  else
     echo "$0: test ${TEST} failed for i=${i}"
     ERR=true
     break
  fi
done
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi

else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi


# ----------------------------------------
# test: replace header
TEST=2
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false

cat > ${OK} <<EOF
From: a
To: b
Subject: New Subject

body
.
EOF

for i in 1 2 3 4 5 6 7 8 9 10 16 32 128 256
do
  ${TPRG} -b ${i} -r '2=Subject: New Subject' < ${IN} > ${OUT}
  if diff ${OK} ${OUT}
  then
     :
  else
     echo "$0: test ${TEST} failed for i=${i}"
     ERR=true
     break
  fi
done
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi

else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi


# ----------------------------------------
# end
if test "${ERRS}" = "0"
then
  rm -f ${IN} ${OK} ${OUT}
  exit 0
else
  echo "${ERRS} error(s)"
  exit 1
fi
